///////////////////////////////////////////////////////////////
//Aufgabe 3 Input-Output
//////////////////////////////////////////////////////////////

boolean[] keys;
int red,green, blue; // aktuelle Farbe
float rot, gruen, blau;//Zufallsfarbe
float punkte; //erreichte Punktzahl
PFont font1, font2;



void setup()
{
  size(300, 390);
  background(255);
  font1 = loadFont("ArialMT-18.vlw");
  font2 = loadFont("ArialMT-12.vlw");
  keys=new boolean[5];
  keys[0]=false;
  keys[1]=false;
  keys[2]=false;
  keys[3]=false;
  keys[4]=false;
  
  red=0; green = 0; blue = 0;
  fill(red,green,blue);
  rect(190,10,100,100);
  text0Ausgeben();//r,g,b Werte anzeigen
  text1Ausgeben();//Erläuternungen
 
}  

void draw() { 
  if( keys[0] && keys[3]) //rot erhöhen
  {  
    rotErhoehen();
  }
 if( keys[0] && keys[4]) //rot verringern
  {  
    rotVeringern();
  }
 if( keys[1] && keys[3]) //grün erhöhen
  {  
    gruenErhoehen();
  }
 if( keys[1] && keys[4]) // grün verringern
  {  
    gruenVeringern();
  }
 if( keys[2] && keys[3]) //blau erhöhen
  {  
    blauErhoehen();
  }
 if( keys[2] && keys[4]) //blau verringern
  {  
    blauVeringern();
  }
   
}
//mit Zufallsfarbe linkes Rechteck füllen
void mousePressed(){
  rot = random(255);gruen = random(255); blau = random(255);
  fill(rot,gruen,blau);
  rect(10,10,100,100); 
  fill(0);
  text2Ausgeben(); 
}

void keyPressed()
{
  if(key=='r') //rot
    keys[0]=true;
  if(key=='g') //grün
    keys[1]=true;
    if(key=='b') //blau
    keys[2]=true;
  if(key=='+')
    keys[3]=true; //erhöhen
  if(key=='-')
    keys[4]=true;  //verringern
  if(key == ENTER){
  ergebnisAnzeigen();
  }
  
}

void keyReleased()
{
   if(key=='r')
    keys[0]=false;
  if(key=='g')
    keys[1]=false;
    if(key=='b') 
    keys[2]=false;
  if(key=='+')
    keys[3]=false; 
  if(key=='-')
    keys[4]=false;  
} 


void rotErhoehen(){
 if (red == 255){
    red = -1;
    }
    red = red +1;
    fill(red,green,blue);
    rect(190,10,100,100); 
    text0Ausgeben();
}

void rotVeringern(){
if (red == 0){
    red = 256;
    }
    red = red -1;
    fill(red,green,blue);
    rect(190,10,100,100); 
    text0Ausgeben();
}

void gruenErhoehen(){
 if (green == 255){
    green = -1;
    }
    green = green +1;
    fill(red,green,blue);
    rect(190,10,100,100);
    text0Ausgeben(); 
}

void gruenVeringern(){
if (green == 0){
    green = 256;
    }
    green = green -1;
    fill(red,green,blue);
    rect(190,10,100,100); 
    text0Ausgeben();
}

void blauErhoehen(){
 if (blue == 255){
    blue = -1;
    }
    blue = blue +1;
    fill(red,green,blue);
    rect(190,10,100,100); 
    text0Ausgeben();
}

void blauVeringern(){
if (blue == 0){
    blue = 256;
    }
    blue = blue -1;
    fill(red,green,blue);
    rect(190,10,100,100); 
    text0Ausgeben();
}

void text0Ausgeben(){
  fill(255);
  noStroke();
  rect(190,110,110,50);//alte Farbwerte löschen
  fill(0);
  textFont(font2);
  text("r =     " + str(red),190,130);
  text("g =     " + str(green), 190,145);
  text("b =     " + str(blue),190,160);
}

void text1Ausgeben(){
  textFont(font1);
  text("Farbmischer-Spiel",65,180);
  textFont(font2);
  text("Zunächst eine Zufallsfarbe durch Mausklick erzeugen",5,200);
}

void text2Ausgeben(){
  fill(255);
  noStroke();
  rect(0,185,300,21);//text1 löschen
  fill(0);  
  textFont(font2);
  text("Das rechte Feld muss die gleiche Farbe bekommen",5,200);
  text("wie das linke Feld!",5,220);
  text("Verwenden Sie die Tasten <r> und <+>",5,240);
  text("um den Rotanteil zu erhöhen!",5,260);
  text("Verwenden Sie die Tasten <r> und <->",5,280);
  text("um den Rotanteil zu verringern!",5,300);
  text("Entsprechend verfahren Sie mit den Farben", 5,320);
  text("grün - Taste <g> und blau - Taste <b>", 5,340);
  text("Die Farbwerte können zwischen 0 und 255 liegen", 5,360);
  text("Für das Ergebnis: ENTERTASTE DRÜCKEN!",5,380);
}

void ergebnisAnzeigen(){
  fill(255);
  noStroke();
  rect(0,185,300,200);//text2 löschen
  fill(0);
  textFont(font2);
  text("r =     " + str(round(rot)),10,130);
  text("g =     " + str(round(gruen)), 10,145);
  text("b =     " + str(round(blau)),10,160);
  punkteAusgeben();
}

void punkteAusgeben(){
  punkte = (rot-red)*(rot-red)+(gruen-green)*(gruen-green)+(blau-blue)*(blau-blue);
  punkte = (442 - sqrt(punkte))*100/442;
  textFont(font2);
  text("Sie haben "+ str(round(punkte))+" von maximal 100 Punkten erreicht!",10,200);
}